* AUXILLIARY DO FILE
* BOOTSTRAPPING MEANS AND STANDARD DEVIATIONS
* THIS FILES GETS RUN FROM MAIN.DO, WHERE THE DATA GETS LOADED AND ITS GLOBALS ARE DEFINED 


* 1. GET ACTUAL VALUES

* col 1
twfe 		$IN   $DYCTRL 			$R1 , ids(h1 h2)	
scalar O1		= _b[O]
scalar n_O1		= _b[n_O]

* col 2
twfe 		$OUT  $DYCTRL 		    $R1 , ids(h1 h2)	
scalar O2		= _b[O]
scalar n_O2		= _b[n_O]

* col 3
xtivreg2 	$IN   $DYCTRL	$H2CTRL $R1 , fe i(h1) 		
scalar O3		= _b[O]
scalar n_O3		= _b[n_O]	
scalar n_I3		= _b[n_lnconspc]

* col 4
xtivreg2 	$IN   $DYCTRL	$H2CTRL $R2 , fe i(h1) 	
scalar O4		= _b[Op]
scalar n_O4		= _b[n_Op]	
scalar n_I4		= _b[n_lnconspc]		
* col 5
xtivreg2 	$OUT   $DYCTRL  $H1CTRL $R1 , fe i(h2) 	
scalar O5		= _b[O]
scalar n_O5		= _b[n_O]	
scalar I5		= _b[lnconspc]				
* col 6
xtivreg2 	$OUT   $DYCTRL  $H1CTRL $R2 , fe i(h2) 	
scalar O6		= _b[Op]
scalar n_O6		= _b[n_Op]	
scalar I6		= _b[lnconspc]				

capture drop matrix observed
matrix observed = O1,n_O1,O2,n_O2,O3,n_O3,n_I3,O4,n_O4,n_I4,O5,n_O5,I5,O6,n_O6,I6
	

* 2. PROGRAM TO BOOTSTRAP
global j=2
capture program drop myboot2
program define myboot2, rclass
	preserve
		* create new O and Op
		*local i=floor(2+runiform()*50) would take a random integer 2-51 (1=original sample), but then some get repeated
		local i = $j // trial with i=1 (original omega)
		*
		estimates use "$output\betas", number(`i')
		gen est=`i'
		merge m:1 n_HHID est using "$output\epsilons", assert(2 3) keep(3) nogen
		predict double Pp 
		gen O  = Pp + res - n_lnconspc
		gen Op = Pp 	  - n_lnconspc 	// omega prime from manuscript
		* flip to get corresponding n_O and n_Op
		tempfile temp
		save `temp', replace
		keep HHID n_HHID O Op
		ren HHID tHHID
		ren n_HHID HHID
		ren tHHID n_HHID
		ren O  n_O
		ren Op n_Op
		merge 1:1 HHID n_HHID using `temp', keep(2 3) nogen
		* take bootstrap sample
		bsample
		* col 1
		twfe 		$IN   $DYCTRL 			$R1 , ids(h1 h2)	
		return scalar O1		= _b[O]
		return scalar n_O1		= _b[n_O]
		* col 2
		twfe 		$OUT  $DYCTRL 		    $R1 , ids(h1 h2)	
		return scalar O2		= _b[O]
		return scalar n_O2		= _b[n_O]
		* col 3
		xtivreg2 	$IN   $DYCTRL	$H2CTRL $R1 , fe i(h1) 		
		return scalar O3		= _b[O]
		return scalar n_O3		= _b[n_O]	
		return scalar n_I3		= _b[n_lnconspc]
		* col 4
		xtivreg2 	$IN   $DYCTRL	$H2CTRL $R2 , fe i(h1) 	
		return scalar O4		= _b[Op]
		return scalar n_O4		= _b[n_Op]	
		return scalar n_I4		= _b[n_lnconspc]		
		* col 5
		xtivreg2 	$OUT   $DYCTRL  $H1CTRL $R1 , fe i(h2) 	
		return scalar O5		= _b[O]
		return scalar n_O5		= _b[n_O]	
		return scalar I5		= _b[lnconspc]				
		* col 6
		xtivreg2 	$OUT   $DYCTRL  $H1CTRL $R2 , fe i(h2) 	
		return scalar O6		= _b[Op]
		return scalar n_O6		= _b[n_Op]	
		return scalar I6		= _b[lnconspc]				
	restore
	global j = $j+1
end

* 3. REPEAT PROGRAM X TIMES 
capture drop Pp-Op
capture timer clear 1
timer on 1
simulate O1=r(O1) n_O1=r(n_O1) ///
		 O2=r(O2) n_O2=r(n_O2) ///
		 O3=r(O3) n_O3=r(n_O3) n_I3=r(n_I3) ///
		 O4=r(O4) n_O4=r(n_O4) n_I4=r(n_I4) ///
		 O5=r(O5) n_O5=r(n_O5) I5=r(I5) ///
		 O6=r(O6) n_O6=r(n_O6) I6=r(I6) , reps($iterations) seed(745651): myboot2 
timer off 1

* 4. CREATE AND SHOW BOOSTRAPPED RESULTS
bstat, stat(observed) n(9032)
timer list 1
di r(t1)/60

* output results
capture drop matrix t
capture drop matrix r
matrix empty=.\.
matrix t=e(b)\e(se)
matrix r1= t[1..2,"O1"],t[1..2,"O2"],t[1..2,"O3"],empty,t[1..2,"O5"],empty
matrix r2= t[1..2,"n_O1"],t[1..2,"n_O2"],t[1..2,"n_O3"],empty,t[1..2,"n_O5"],empty
matrix r3= empty,empty,empty,t[1..2,"O4"],empty,t[1..2,"O6"]
matrix r4= empty,empty,empty,t[1..2,"n_O4"],empty,t[1..2,"n_O6"]
matrix r5= empty,empty,t[1..2,"n_I3"],t[1..2,"n_I4"],empty,empty
matrix r6= empty,empty,empty,empty,t[1..2,"I5"],t[1..2,"I6"]
matrix r=r1\r2\r3\r4\r5\r6
matrix list r

set more off
clear
set obs 12
svmat r
foreach x of varlist r* {
	gen str3 stars = ""
	replace  stars = "*" 	if `x'/`x'[_n+1]>=1.645 & `x'/`x'[_n+1]<1.960 & mod(_n,2)~=0 & `x'~=.
	replace  stars = "**" 	if `x'/`x'[_n+1]>=1.960 & `x'/`x'[_n+1]<2.576 & mod(_n,2)~=0 & `x'~=.
	replace  stars = "***" 	if `x'/`x'[_n+1]>=2.576 					  & mod(_n,2)~=0 & `x'~=.
	tostring `x', replace force format(%9.3f)
	replace  `x' = "" if `x'=="."
	replace  `x' = `x' + stars 
	replace  `x' = "(" + `x' + ")" if mod(_n,2)==0 & `x'~=""
	drop stars
	}
gen var 	= "$\Omega_{RD}$" 			in 1
replace var = "$\Omega_{DR}$" 			in 3
replace var = "$\Omega_{RD}^{\prime}$" 	in 5
replace var = "$\Omega_{DR}^{\prime}$"  in 7
replace var = "$ I_{D}$"				in 9
replace var = "$ I_{R}$"				in 11
order var
replace r6=r6 + "\\" if _n!=_N
list, separator(4)
